/*/
/* re-framer & reverse tree navigator
/* (c) Systinet 2001-2004
/*
/*/

var fileQuery='';

function checkMe(loc) {
  parseQuery(loc);
  if(window.top.location==window.location) { location.replace(loc + "index.html?" + fileQuery); return true; } // not in frame context? force it!
  if((typeof window.parent.leftFrame) == "undefined") return true;
  var testLoc=window.parent.leftFrame.menuPage.document.location;
  testLoc=testLoc.toString();
  var testNode=returnNode(); // what node should be highlighted..?
  if(testLoc.indexOf("menu.html") < 0) { 
    storePersTreeState(testNode);
  } else {
    if(typeof(window.top.focusedNode)!="undefined") {  if(window.top.focusedNode!=testNode)  { window.parent.leftFrame.menuPage.focusNode(testNode); } } // focus tree
  }
}

// changes the current state of the menu tree
function storePersTreeState(nodeId) {
    window.parent.leftFrame.menuPage.document.cookie = "TreeState=" + nodeId;
}

function parseNodeName(myRawNode) { 
   // this function parses the rawNodeName (node.name) to nodeName (node_name) to replace RegExp
      var myRawNodeChunks=new Array();
          myRawNodeChunks=myRawNode.split('.'); // substitute the faulty RegExp function by exploding the raw nodename...
      var myNode='';
          for(var i=0; i<myRawNodeChunks.length; i++) { 
                                                       myNode+=myRawNodeChunks[i]; 
                                                       if(typeof(myRawNodeChunks[(i+1)])!='undefined') { myNode+='_'; }
                                                       // ...and by joining it back using the "_".
                                                      }
     return myNode;
}

function parseQuery(loc) {
  var myLoc=document.location;
      myLoc=myLoc.toString();

  var myLocPathChunks=new Array();
      myLocPathChunks=myLoc.split('/'); // get parts of the URL
  var myFileQuery=myLocPathChunks[(myLocPathChunks.length-1)];

  var idx=1;
  while(loc.indexOf('/') > -1) {
    idx++;
    myFileQuery=myLocPathChunks[(myLocPathChunks.length-idx)] + "/" + myFileQuery;
    loc=loc.substring(loc.indexOf('/')+1);
  }

  fileQuery=myFileQuery; 

  return true;
}

function returnNode() {
  // This function parses current document's URL and turns it into tree node ID.
      var myFileQuery=fileQuery;
          // we need the last part (file and anchor).. and we dump it to a global variable
      var myFileQueryChunks=new Array();
          myFileQueryChunks=myFileQuery.split('#'); // try to get the anchor, if present..
      var pageQueried   = myFileQueryChunks[0].replace('.html',''); // what's the page's rawNodeName?
      var anchorQueried = myFileQueryChunks[1];                     // what's the anchor's rawNodeName?
      var myRawNode=(typeof(anchorQueried)!='undefined') ? anchorQueried:pageQueried; // if anchor available, use it's rawNodeName
      var myNode=parseNodeName(myRawNode); // get the clean nodeName

      if(window.top.location!=window.location) { // no reason to call this, if we are frameless..
         if(typeof(window.top.nodeNames)!="undefined") {
            //var nodeExists=typeof(window.top.nodeNames.indexOf(myNode));
            var searchValue=window.top.nodeNames.indexOf(myNode);
            if(searchValue==-1) { myNode=parseNodeName(pageQueried); } // if no such nodeName as the anchor, use the page nodeName instead
            searchValue=window.top.nodeNames.indexOf(myNode);
            if(searchValue==-1) { myNode='root'; } // if still no such node, just go to the root..
         } else {
           myNode=parseNodeName(pageQueried); // if you don't recognize nodeNames across frames (e.g. Opera), just follow the pages...:-(
         }
     }
         
  return myNode;      
}

function focusMe(what) {
 checkMe(what); // just a stupid wrapper to not to cause conflict in javascript...
}

function hiliteNode(what) {
   what=what.toString();
   var tmpArr=new Array();
   var separator=(what.indexOf('/')==-1) ? '\\':'/';
   tmpArr=what.split(separator);
   what=tmpArr[tmpArr.length -1];
   var tmpLoc=window.top.frameWin.toolWin.document.location.toString();
   if(tmpLoc.indexOf('toc')!=-1) {
      window.top.frameWin.toolWin.zoomChild(what);
      return window.top.frameWin.toolWin.Highlight(what);
   }
   return false;
}
//checkMe(''); // run for the first time..